# MovieList by gutemine
#
from Tools.FuzzyDate import FuzzyTime
from Tools.Directories import *
from ServiceReference import ServiceReference
from enigma import eServiceReference, eServiceCenter, iServiceInformation
from twisted.web2 import resource, http_headers, responsecode, http
import os
__version__ = "0.2.1"

class WIMovielist(resource.Resource):
    

    title = "DMM7025 Movielist by gutemine"
     
    sessions = [ ]
    
    def __init__(self,sessions):
        self.sessions = sessions
   
    
    def render(self, req):
        """ rendering server response """
        command = req.args.get("movielist",None)
        if command is None:

            html  = "<html><head><title>%s</title></head><body>" %self.title
            html += "</body>"
            html += "</html>"
            html += "<hr>"
            
            root = eServiceReference("2:0:1:0:0:0:0:0:0:0:" + resolveFilename(SCOPE_HDD))
            

	    self.list = [ ]
        
	    self.root  = root
		
	    self.serviceHandler = eServiceCenter.getInstance()
	    list = self.serviceHandler.list(root)
		
	    tags = set()
		
	    if list is None:
               html += "No Movies found"
		
	    while 1:
			serviceref = list.getNext()
			if not serviceref.valid():
				break
			if serviceref.flags & eServiceReference.mustDescent:
				continue
			info = self.serviceHandler.info(serviceref)
			if info is None:
				continue
		        text = info.getName(serviceref)
			begin = info.getInfo(serviceref, iServiceInformation.sTimeCreate)
			
			# convert space-seperated list of tags into a set
			this_tags = info.getInfoString(serviceref, iServiceInformation.sTags).split(' ')
			if this_tags == ['']:
				this_tags = []
			this_tags = set(this_tags)
			
			# filter_tags is either None (which means no filter at all), or 
			# a set. In this case, all elements of filter_tags must be present,
			# otherwise the entry will be dropped.			
			filter_tags = None
			if filter_tags is not None and not this_tags.issuperset(filter_tags):
				continue
			
			tags |= this_tags
			self.list.append((serviceref, info, begin, -1))
		        text = info.getName(serviceref)
		        description = info.getInfoString(serviceref, iServiceInformation.sDescription)
		        begin_string = ""
		        if begin > 0:
			   t = FuzzyTime(begin)
			   begin_string = t[0] + ", " + t[1]
			   
                        html += "%s<br>%s<br>%s<br>%s<hr>" %  (text,description,begin_string,len)
		

            html += "</body>"
            html += "</html>"
                 
                
            return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
        










